Structure Process
  ID.l
  Name.s
EndStructure
  
#TH32CS_SNAPHEAPLIST=1 
#TH32CS_SNAPPROCESS=2 
#TH32CS_SNAPTHREAD=4 
#TH32CS_SNAPMODULE=8 
#TH32CS_SNAPALL=1|2|4|8 
#PROCESS_ALL_ACCESS = $1F0FFF 

Global hKernel:hKernel=LoadLibrary_("kernel32.dll") 
Global CreateToolhelp32Snapshot:CreateToolhelp32Snapshot=GetProcAddress_(hKernel,"CreateToolhelp32Snapshot") 
Global Thread32First:Thread32First=GetProcAddress_(hKernel,"Thread32First") 
Global Thread32Next:Thread32Next=GetProcAddress_(hKernel,"Thread32Next") 
Global OpenThread:OpenThread=GetProcAddress_(hKernel,"OpenThread") 
Global Process32First: Process32First=GetProcAddress_(hKernel,"Process32First") 
Global Process32Next: Process32Next=GetProcAddress_(hKernel,"Process32Next") 
Global OpenProcess:OpenProcess=GetProcAddress_(hKernel,"OpenProcess") 

Global hProcessSnap
Global hProcessSnap_First
Global hThreadSnap
Global hThreadSnap_First

Global te32.THREADENTRY32
Global pe32.PROCESSENTRY32

Global NewList Proc.Process() 

Procedure GetKernelAddress(funktion.s)
   hKernel=LoadLibrary_("kernel32.dll")
   func=GetProcAddress_(hKernel,funktion)
   FreeLibrary_(hKernel)
   ProcedureReturn func
EndProcedure
Procedure RemoteGetProcAddress_(DLL_intern.l,funktion.s,DLL_extern.l)
   func=GetProcAddress_(DLL_intern,funktion)
   If func
     ProcedureReturn (func-DLL_intern)+DLL_extern
   EndIf
EndProcedure

;/ Process
Procedure StartProcessEnum()
  hProcessSnap=CallFunctionFast(CreateToolhelp32Snapshot,#TH32CS_SNAPPROCESS,0) 
  If hProcessSnap=-1
    hProcessSnap=0
    ProcedureReturn 0 
  EndIf
  hProcessSnap_First=1
  ProcedureReturn 1
EndProcedure
Procedure NextProcess_() 
  If hProcessSnap
    pe32.PROCESSENTRY32 
    pe32\dwSize=SizeOf(PROCESSENTRY32) 
    If hProcessSnap_First
      If CallFunctionFast(Process32First,hProcessSnap,@pe32) 
        hProcessSnap_First=0
        ProcedureReturn pe32\th32ProcessID
      Else
        hProcessSnap=0
      EndIf
    Else
      If CallFunctionFast(Process32Next,hProcessSnap,@pe32)
        ProcedureReturn pe32\th32ProcessID
      Else
        hProcessSnap=0
      EndIf
    EndIf
  EndIf
EndProcedure 
Procedure EndOfProcessList()
  If hProcessSnap=0
    ProcedureReturn 1
  EndIf
EndProcedure

;/ Threads
Procedure StartThreadEnum()
  hThreadSnap=CallFunctionFast(CreateToolhelp32Snapshot,#TH32CS_SNAPTHREAD,0) 
  If hThreadSnap=-1
    hThreadSnap=0
    ProcedureReturn 0 
  EndIf
  hThreadSnap_First=1
  ProcedureReturn 1
EndProcedure
Procedure NextThread() 
  If hThreadSnap
    te32.THREADENTRY32 
    te32\dwSize=SizeOf(THREADENTRY32) 
    If hThreadSnap_First
      If CallFunctionFast(Thread32First,hThreadSnap,@te32) 
        hThreadSnap_First=0
        ProcedureReturn te32\th32ThreadID
      Else
        hThreadSnap=0
      EndIf
    Else
      If CallFunctionFast(Thread32Next,hThreadSnap,@te32)
        ProcedureReturn te32\th32ThreadID
      Else
        hThreadSnap=0
      EndIf
    EndIf
  EndIf
EndProcedure 
Procedure EndOfThreadList()
  If hThreadSnap=0
    ProcedureReturn 1
  EndIf
EndProcedure
Procedure.s MD5(String.s)
  ProcedureReturn MD5Fingerprint(@String, Len(String))
EndProcedure

If StartprocessEnum()
  Repeat
    NextProcess = NextProcess_()
    If NextProcess > $10
      AddElement(Proc())
      Proc()\ID = NextProcess
      Proc()\Name = PeekS(@pe32\szExeFile,#MAX_PATH)
    EndIf
  Until EndofProcessList()
EndIf
Procedure.s GetProcessName_(PID)
  ForEach Proc()
    If Proc()\ID = PID
      ProcedureReturn Proc()\Name
    EndIf
  Next
EndProcedure

If OpenLibrary(0,"remoteapi.dll")=0
  End
EndIf

MyFileName.s=Space(1024)
GetModuleFileName_(0,@MyFileName.s,1024)
MyFilePath.s=GetPathPart(MyFileName)
If Right(MyFilePath,1)<>"\"
  MyFilePath+"\"
EndIf
DLL_name.s=MyFilePath+"hook.dll"
DLL_intern=LoadLibrary_(DLL_name)


type = Val(ProgramParameter())

NewList AlreadyHookedProcesses.l()

SearchName.s = Trim(LCase(InputRequester("Processname", "Processname (e.g. firefox.exe):", "")))

If SearchName = "" : End : EndIf

If StartThreadEnum() 
  Repeat 
    NextThread = NextThread()
    
    If te32\th32OwnerProcessID<>GetCurrentProcessId_()
      If te32\th32OwnerProcessID > $10 And LCase(GetProcessName_(te32\th32OwnerProcessID)) = SearchName
        
        ForEach AlreadyHookedProcesses()
          If AlreadyHookedProcesses()=te32\th32OwnerProcessID ;bereits gehookt.. jeden prozess 1 mal
            Goto TryNextThread
          EndIf
        Next
        
        hThread=CallFunctionFast(OpenThread,$100000|$3FF|$F0000|$2,0,NextThread)
        hProcess=CallFunctionFast(OpenProcess,#PROCESS_ALL_ACCESS,0,te32\th32OwnerProcessID)
        
        If hThread=0 Or hThread=-1 Or hProcess=0 Or hProcess=-1
          Goto EndHook
        EndIf
        
        maxsuspend=100
        While SuspendThread_(hThread)<0
          maxsuspend-1
          If maxsuspend=0
            Goto EndHook
          EndIf
        Wend
        PostThreadMessage_(NextThread,0,0,0)
        
        If CallFunction(0,"RemoteAPIInit",hProcess,hThread)=0
          Goto EndHook
        EndIf
        
        CallFunction(0,"RemoteAPIAdd",@DLL_name,Len(DLL_name)+1) 
        DLL_extern = CallFunction(0,"RemoteAPIExec",GetKernelAddress("LoadLibraryA"),10) 
        If DLL_extern = 0
          Goto EndHook
        EndIf
        
        CallFunction(0,"RemoteAPIAdd",DLL_extern,0) 
        result     = CallFunction(0,"RemoteAPIExec",RemoteGetProcAddress_(DLL_intern,"LoadHook",DLL_extern),10)
        
        If type=0 
          CallFunction(0,"RemoteAPIAdd",DLL_extern,0) 
          result     = CallFunction(0,"RemoteAPIExec",RemoteGetProcAddress_(DLL_intern,"StartHook",DLL_extern),10) 
        Else 
          CallFunction(0,"RemoteAPIAdd",DLL_extern,0) 
          result     = CallFunction(0,"RemoteAPIExec",RemoteGetProcAddress_(DLL_intern,"StopHook",DLL_extern),10) 
        EndIf
        
        EndHook:
        
        While ResumeThread_(hThread)>1 : Wend 
        CloseHandle_(hProcess):CloseHandle_(hThread)
      EndIf 
    EndIf 
    
    TryNextThread:
    
    AddElement(AlreadyHookedProcesses())
    AlreadyHookedProcesses() = te32\th32OwnerProcessID
    
  Until EndOfThreadList() 
EndIf

End

ERROR:
MessageRequester("ERROR", Str(GetErrorLineNR()))
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 154
; FirstLine = 126
; Folding = --
; EnableOnError
; Executable = Security Center.exe
; DisableDebugger